package de.intevation.flys.importer;

import java.util.List;

import org.hibernate.Session;
import org.hibernate.Query;

import de.intevation.flys.model.WaterlevelQRange;
import de.intevation.flys.model.WaterlevelValue;


/** W and a station. */
public class ImportWaterlevelValue {

    private Double station;
    private Double w;

    private WaterlevelValue peer;


    public ImportWaterlevelValue(Double station, Double w) {
        this.station = station;
        this.w       = w;
    }


    public void storeDependencies(WaterlevelQRange qRange) {
        getPeer(qRange);
    }


    public Double getStation() {
        return this.station;
    }


    public Double getW() {
        return this.w;
    }

    public WaterlevelValue getPeer(WaterlevelQRange qRange) {
        if (peer == null) {
            Session session = ImporterSession.getInstance().getDatabaseSession();
            Query query = session.createQuery(
                "from WaterlevelValue where " +
                "   qrange=:qrange and " +
                "   station=:station and " +
                "   w=:w"
            );

            query.setParameter("qrange", qRange);
            query.setParameter("station", station);
            query.setParameter("w", w);

            List<WaterlevelValue> values = query.list();

            if (values.isEmpty()) {
                peer = new WaterlevelValue(qRange, station, w);
                session.save(peer);
            }
            else {
                peer = values.get(0);
            }
        }

        return peer;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
